
;**********************************************************************
;    Analog - Digital PSU (-  )				*
;    Filename:	    Psu.asm                                           					*
;    Date: 06.10.11                                               		 *
;    File Version:   2.0                                                         						*
;    Author:     Kusnetsov A  .,  .			                  *
;      8											*
;**********************************************************************
	list      p=16f88          		; list directive to define processor
	#include <p16F88.inc>        ; processor specific variable definitions

	errorlevel  -302              ; suppress message 302 from list file
 	errorlevel  -305
	__CONFIG  _CONFIG1, _CP_OFF & _CCP1_RB0 & _DEBUG_OFF & _WRT_PROTECT_OFF & _CPD_OFF & _LVP_OFF & _BODEN_OFF & _MCLR_OFF & _PWRTE_ON & _WDT_OFF & _INTRC_IO
	__CONFIG _CONFIG2,  _IESO_OFF & _FCMEN_OFF

;**********************************************************************
	include 		"Definit.inc" 	;   
;**********************************************************************

;**********************************************************************
	ORG		0x000			; processor reset vector
	goto	INIT			; go to beginning of program

;;**********************************************************************
	ORG		0x004			; interrupt vector location
;;**********************************************************************
;Innterrupt service routine
;**********************************************************************
			PUSH						; 
			btfsc	PIR1, TMR1IF		;Timer 1 interrupt?
			goto	Service_TMR1
			btfss	INTCON,TMR0IF		;Timer 0 interrupt?
			goto	ISR_E				;,  
			btfss	INTCON,TMR0IE
			goto	ISR_E
			clrf	PCLATH
			goto	Load_TMR0

Service_TMR1		clrf	PORTA		; 
					bcf		T1CON, TMR1ON	; 1
					goto	ISR_Ex			;  
;-------------------  --------------------------------------------------------
Load_TMR0	
			movlw 	.152
			movwf 	TMR0	 	
;**********************************************************************
Key_off			;  OFF		
;**********************************************************************			
				clrf	PORTA		; 
				load_f	0xFF, PORTB	
				
				btfss	knopka				; ?
				goto	Check_flag_off			;
		
				bsf		kn_off				;,    
				bcf		kn_press1
				bcf		kn_press2
				bcf		kn_press3
				
				decfsz 	cnt_off					; 
		        goto 	Display_Control
		        	
		        movlw	.200					;   
				movwf	cnt_off 
		        									;  
		        bcf		kn_off
				btfsc 	mode_off				
				goto	Switch_ON

Switch_OFF	Off_Out					
				
;				load_f	46, digit
;				load_f	0x1C, digit+1
;				load_f	0x1C, digit+2
;				bsf		sav_on
				
				bsf		mode_off
				goto	Display_Control
				
Switch_ON		btfss	over_time
				btfsc	SU_off
				goto	D_C	
				
				On_Out
D_C				bcf		mode_off
				goto	Display_Control
				 
Check_flag_off	btfss	kn_off				;     ?
				goto	Display_Control		;
											
				bcf		kn_off			;
				movlw	.5					;   
				movwf	cnt_off 
				;bcf		sav_on			
;**********************************************************************
Display_Control		;  
;**********************************************************************			
			movlw	digit      		;   
			addwf  	cnt_digit, w     
			movwf	FSR   	
			movf    INDF,w     
			
			btfss	displ_off		;  ,   
			movwf PORTB			;   PORTB 7- 
			
			
;-----------------------   ------------------------------
Display_Mask
			movfw	place
			addwf	PCL
R1			movlw	b'01000000'
			goto	Place_ON
R2			movlw	b'10000000'
			goto	Place_ON	
R3			movlw	b'00000001'

Place_ON	movwf	PORTA		;andwf		
;------------------    -----------------------
Prepare	
			movfw	place
			addlw	.2
			movwf	place
			incf    	cnt_digit 	
		    	movlw   .3       
		    	subwf   cnt_digit, w    
		    	btfss   	STATUS, Z   ;    ? 
		    	goto    	ISR_E     	;   =0
		    	clrf 	cnt_digit     ;  
		    	clrf		place
		    	bsf		big_cykle   ;    
		    	
		    	incf		count_tmr		;   
		    	movfw	count_tmr
		    	sublw 	.50
			btfss 	STATUS, Z 			;50  ?
			goto	Mode_blink				;no, done
			clrf 	count_tmr 				;,  clear counter
			bsf		secunda				;  
;----------------P  -----------------------------------------------------------	
Mode_blink	
			btfss	flash				;  
			goto	ISR_E
			decfsz	count_impuls	
			goto	ISR_E
			btfss	displ_off			; 
			goto	lab1
			bcf		displ_off			; 
			goto	lab2	
		
lab1		bsf		displ_off			; 
lab2		load_f	.15, count_impuls       
;---------------------------------------------------------------------------------
ISR_E		bsf		inter_f			;  
			bcf		INTCON,TMR0IF	
			btfss	mode_off
			goto	ISR_Ex	
			
			movlw 	.244		 		; Value to load into TMR1H
			movwf	TMR1H	
			clrf	 	TMR1L 		; Write Lowe byte
			bsf		T1CON, TMR1ON	; 1
ISR_Ex		bcf		PIR1, TMR1IF	;  
			POP						; 
			
			retfie
;**********************************************************************

;===================================================================				
INIT
;*********************************************************************
;***************  MK****************************
;*********************************************************************
		BANK0
		CLRF 		PORTA 			; PORTA
		CLRF 		PORTB 			; PORTB
		BANK1
		MOVLW    B'01111100'		;  
		MOVWF    OSCCON			;  8
		MOVLW	 .3
		MOVWF	OSCTUNE
		MOVLW    B'10000110'		;  ,
		MOVWF    OPTION_REG	;   
	
		 ;****** ***********
		 
		 ;PORTA,0 -  3
		 ;PORTA,1 -   -  "-"
		 ;PORTA,2 -   -  "+"
		 ;PORTA,3 -   - LM35
		 ;PORTA,4 -  
		 ;PORTA,5 -  -   
		 ;PORTA,6 -  1
		 ;PORTA,7 -  2
		 
		 ;PORTB,0 - , PWM
		 ;PORTB,1 - , LD - A
		 ;PORTB,2 - , LED - B
		 ;PORTB,3 - , LED - C
		 ;PORTB,4 - , LED - D
		 ;PORTB,5 - , LED - E
		 ;PORTB,6 - , LED - F
		 ;PORTB,7 - , LED - G
	
		MOVLW	B'00101110'	; PORTA 
		MOVWF	TRISA			
		clrf	TRISB		; PORTB
	
			 
		CLRF     PIE2			; 	
		CLRF     PIE1
			 
		; 		 		 
		MOVLW	  B'00001110'		;AN1
		MOVWF	  ANSEL			;  
		
		MOVLW    B'11000000'   	;,     Vref =Vdd
		MOVWF    ADCON1
				 
		; 
		MOVLW    B'00000111'   	; 
		MOVWF    CMCON
		
		clrf			CVRCON		   	;  
			
		BANK0
		MOVLW    B'01010001'   	;Fosc/16, AN1, Stop, ADC_ON
		MOVWF    ADCON0
		 
		CLRF     	PORTA			;     
		CLRF     	PORTB			;  
		CLRF     	PIR1
		CLRF     	PIR2 		
		
		; 
		CLRF     CCP1CON		;  PWM
		CLRF		TMR2			; 
		BANK1
		load_f		.255, PR2		;  
		
		;bsf			PIE1, TMR2IE	;  2 
		BANK0
		CLRF		CCPR1L		;  0
		load_f		.6, T2CON		; 2,  1:14,  1:1
		load_f		.12, CCP1CON	;  PWM
		
		BANK3
		CLRF     EECON1		;   
			
		movlw	 b'11100000'
		movwf	 INTCON		    ;   0

		BANK0
;--------------- 0, c  -------------------------------		 
		load_f	 .104, TMR0
;------------------- 1,     ----------------------	
			 movlw 		.244				;     TMR1
			 movwf 		TMR1H 		
			 clrf	 		TMR1L 		
			 
			 ;movlw		 b'00000001'	; 1,  1:1
			 ;movwf 		T1CON
			 
;---------------------  ---------------------------------------
Clear_Array		
		load_f	20, FSR
Cloop
		clrf		0
		incf		FSR, f
		movfw		FSR
		addlw		-0x7F			
		bnz			Cloop
;--------------------------------------------------------------------------------------------------------------------		
				;load_f	.10, Duty_cycle			;  1V
				load_f 	.60, cnt_1 	
				load_f 	.15, cnt 					;  
				load_f 	.5, cnt_off
				load_f	.15,count_impuls    
				load_f	.15, speed_repeat
				load_f	.2, hister
				
				bsf		kn_enable
				bsf		min_elapsed
				;call		Time_compare
				;goto	$-1

;*****************		u2.0**************************************		
			nop
			load_f		0xC6, digit			;u
			load_f		0xF2, digit+1			;2.	
			load_f		48, digit+2			;0.	
            call		delay_3s				;
              	
			
              	
;***************************************************************			
	
			call		EE_read		; EEPROM, 
			movf_f	sp_t, r_sim		; 
			movf_f	sp_t+1, r_dec	;  
			call		BCD_BC1	;
			
			load_f	46, digit		;  oFF
			load_f	0x1C, digit+1
			load_f	0x1C, digit+2
			call	delay_3s			
			
			movf_f	sp_u, Duty_cycle		;  
			bsf		mode_off				;    
			
			bsf		T1CON, TMR1ON	; 1
			bsf     STATUS,RP0		;bank 1
			bsf		PIE1, TMR1IE	;   1
			bcf     STATUS,RP0		;bank 0
			
			bcf		PIR1, TMR1IF	;  
			
			
		
			
			
			
			goto	Loop
;**************      ***********************
TABLE
			    clrf    	PCLATH
			    andlw   	H'0F'
				addwf   	PCL, f				;  
				dt	80, 0xF2, 48, 60, 32, 24, 04, 0xB0, 00, 20

;********************  **********************************				
Update			btfss	edit_on			;mode_set				
				btfsc	sav_on
				goto	Loop			;Key_scan1
							
				movfw		n_param
				clrf    	PCLATH
       			addwf   	PCL, f	
				goto		V_View
				goto		T_View
				goto		H_View
				
;-----------------------------  --------------------------------------
V_View
				movf_f	digit_u,	digit
				movf_f	digit_u+1, digit+1
				movf_f	digit_u+2, digit+2	           	
		        	bsf		kn_enable
		        	goto	Loop				;
;----------------------------  --------------------------------------
T_View		
				movf_f	digit_t, digit
				movf_f	digit_t+1, digit+1
				movf_f	digit_t+2, digit+2        	
		        	bcf		kn_enable
		        	goto	Loop				;
;-------------------------  ----------------------------------
H_View				bcf		kn_enable
						btfss	min_elapsed
						goto	Loop			;

Format1L				movfw 	count_hour		;  
	      				call    	TABLE
	       				movwf   digit
	       				       				
	       				load_f		16, digit+1	; 2   "h"
												
						movfw	mins_10		;  
						call    	TABLE				
						movwf   digit+2
											
Exit_L_Format			bcf		min_elapsed
							
;*************************************************************************		        
;****************************  Cykle   *************************************
;*************************************************************************
Loop			btfss	big_cykle		;     	
				goto	$-1				;
				bcf		big_cykle		;
				
				incf	count_sampl		;  
				movfw 	count_sampl
				sublw 	.16
				bz		Elapsed

Converting		call		Measurement
				call		Time_compare				
				goto	Key_scan1		;
				
Elapsed			clrf		count_sampl		
				call		Format	;
				goto	Update

;-------------------  U--------------------------------
Measurement
Ch1				btfsc		mode_off
				goto		Uref
Uout			bcf			ADCON0, 4		;   Uout	
				bsf			ADCON0, 3
				goto		$+3
Uref			bcf			ADCON0, 3		;   Uref
				bsf			ADCON0, 4
				call		delay_1ms
				movf_f		Usum_H, H_sum
				movf_f		Usum_L, L_sum
				call		AD_convert		;ADC 
				movf_f	 	H_sum, Usum_H
				movf_f	 	L_sum, Usum_L
				call		DELAY_40
				;goto		Clock_count
;-------------------- -------------------------------------------
Ch2				bsf			ADCON0, 4		;   T
				bsf			ADCON0, 3
				call		DELAY_40	
				movf_f		Tsum_H, H_sum
				movf_f		Tsum_L, L_sum
				call		AD_convert		;ADC 
				movf_f	 	H_sum, Tsum_H
				movf_f	 	L_sum, Tsum_L
;*********************** **************************************		
;Clock_count		
;		btfss	PIR1, 0			;  1
;		return					;goto	Key_scan1		;  
;		bcf		PIR1, 0
;		movlw 	.11		 		; Value to load into TMR1H
;		movwf	TMR1H	
;		clrf	 	TMR1L 		; Write Lowe byte
;-----------------------------------------------------------------------------------------------------		
Test_count			btfss	mode_off		;    -  
					btfsc	over_time		;   -  
					return		
					;btfss	reset_oh
					;goto	Count_s
					;On_Out
					;bcf			flash			;  
					;bcf			displ_off			; 	
					;bcf			reset_oh
;-----------------------------------------------------------------------------------------------------		
Count_s		btfss	secunda			; ?
				return						;		  
		
		incf		count_sec		;,  
		bcf		secunda		;  
		
		movfw	count_sec
		sublw 	.60
		btfss 	STATUS, Z 				; 60 seconds elapsed ?
		return								;no, done
		clrf 	count_sec 					;clear seconds
		incf 	count_min				 	; increment minutes
		
		
		movfw	 count_min
		sublw 	.10
		btfss 	STATUS, Z 				; 10  elapsed?
		return								; no, done
		clrf 	count_min					; clear minutes
		incf 	mins_10					;    
		bsf		min_elapsed				; - 10  o	
;--------------------------------------------------------------------------------------------------		
		
Count_h		movfw	 mins_10
				sublw 	.6
				btfss 	STATUS, Z 				; 6  ?
				return								; no, done
				clrf 	mins_10					; , clear 10 minutes
				incf 	count_hour					; increment  hours
		
				
		movfw 	count_hour
		sublw 	.10
		btfss 	STATUS, Z 				; 10 hours elapsed?
		return							; no, done
		clrf 	count_hour				; clear hours
		return
;		incf		hours_10				;   
;		bsf		hours10_elapsed		; - 10  
;		
;		movfw 	hours_10
;		sublw 	.100
;		btfss 	STATUS, Z 				; 100 hours elapsed?
;		return	 					;,   
;		clrf		hours_10				
;		return
;**********************  ****************************
Key_scan1		btfsc	kn_off				; off ?
				goto	Loop			;da
				
				btfss	knopka				; select ?
				goto	Check_flag			;
		
				bsf		kn_press1			;,    
				decfsz 	cnt_1					; 
		        	goto 	Loop
		        	movlw	.50					;   
				movwf	cnt 
		        	bsf		long_flag			
		        	goto	Long_press		;  
				 
Check_flag		btfss	kn_press1			;     ?
				goto	Key_scan2			;
											
				bcf		kn_press1			;
				movlw	.50					;   
				movwf	cnt_1 
				btfss	long_flag
				goto	Select_sw			;  
				bcf		long_flag			;  
				
				bcf		sav_on
				btfsc	edit_on				
			
				clrf			mode
				
				
				goto	Loop

;----------------------  -----------------------------------------
Long_press			goto	Press_mode
					goto	Loop

;----------------------  -----------------------------------------
Select_sw		incf			n_param
				movlw   	.3       
			    	subwf   	n_param, w    
			    	btfss   		STATUS, Z  
			    	goto    		$+2
			    	clrf 		n_param     
				bcf			kn_enable	;  +-
				movf_f		n_param, mode
				
				bcf			edit_on			; SET 
				bsf			min_elapsed
				bcf			flash			;  
				bcf			displ_off			; 	
				goto		Update

;*************************************************************************
Key_scan2		btfss	kn_enable	; ?		
				goto	Loop;
			
				bcf		inter_f			;
				btfss	inter_f
				goto	$-1
							
				btfsc	kn_off				; off ?
				goto	Loop			;da
				
				btfss	knopka				; ?
				goto	Check_flag2			;
		
				bsf		kn_press2			;,    
				decfsz 	cnt					; 
		        	goto 	Loop			
		        	movfw	speed_repeat		;movlw	.16					;   
				movwf	cnt 
		        	bsf		long_flag			
		        	goto	Dw_Long_sw			;Long_Scroll			; 
				 
Check_flag2	btfss	kn_press2			;   ?
				goto	Key_scan3			;
											
				bcf		kn_press2			;
				movfw	speed_repeat		;movlw	.16					;   
				movwf	cnt 
				btfss	long_flag
				goto	Dw_Short_sw			;Short_Scroll		;  
				bcf		long_flag			;  
				load_f	.15, speed_repeat
				goto	Loop

Dw_Long_sw		btfsc	edit_on		;   SP
					goto	Value_DW1
					load_f	.10, step
					call		Sub
					goto	Loop

Dw_Short_sw		btfsc	edit_on		;   SP
					goto	Value_DW0
					load_f	.1, step
					call		Sub
					goto	Loop
;-----------------------------------------------------------------------------------------------------
Key_scan3		bcf		inter_f	
				btfss	inter_f
				goto	$-1
			
				btfsc	kn_off				; off ?
				goto	Loop			;da
				
				btfss	knopka				; ?
				goto	Check_flag3			;
		
				bsf		kn_press3			;,    
				decfsz 	cnt					; 
		        	goto 	Loop			
		        	movfw	speed_repeat		;movlw	.16					;   
				movwf	cnt 
		        	bsf		long_flag3			
		        	goto	Long_sw			;Long_Scroll			; 
				 
Check_flag3	btfss	kn_press3			;   ?
				goto	Loop		;
											
				bcf		kn_press3			;
				movfw	speed_repeat		;movlw	.16					;   
				movwf	cnt 
				btfss	long_flag3
				goto	Short_sw			;  
				bcf		long_flag3			;  
				load_f	.15, speed_repeat
				goto	Loop

Long_sw		btfsc	edit_on		;   SP
				goto	Value_UP1	
				load_f	.10, step
				call		Add
				goto	Loop

Short_sw		btfsc	edit_on		;   SP
				goto	Value_UP0
				load_f	.1, step
				call		Add
				goto	Loop

;----------- ----------------------------------------------------------------
Add		addwf	Duty_cycle, w	
			btfsc   	STATUS, C
			movlw	.255
			movwf	Duty_cycle	
			return

;------------- ------------------------------------------------------------
Sub			subwf	Duty_cycle, w
			btfss   	STATUS, C
			clrw
			movwf	Duty_cycle
			return
				

;**************************************************************************
;***************** ***********************************
;**************************************************************************
Press_mode			btfsc		sav_on			;   ,   
						goto		Loop			;return

;-------------------------------------------------------------------------------------------						

Select					load_f	.15, speed_repeat
						
						movlw	HIGH(Select)	;
						movwf	PCLATH
		       			movfw		mode	;n_param 
		       			addwf   	PCL	
						goto		Save_Value
						goto		Load_Tsp
						goto		Load_Hsp
;**********************  SP *****************************
Save_Value			load_f	h'24', digit		;  SAU
						load_f	h'10', digit+1
						load_f	h'82', digit+2	
						bsf		sav_on	
						movf_f	n_param, mode
						bcf			edit_on			; 
						bcf			flash			; 
						bcf			displ_off			; 
						bsf			min_elapsed
						nop
						nop
						nop
						nop
						nop
						nop
;------------------------------------------------------------------------------------------------------						
Save_sel				movlw	HIGH(Save_sel)	;
						movwf	PCLATH
		       			movfw		n_param 
		       			addwf   	PCL	
						goto		Save_U
						goto		Save_T
						goto		Save_H

Save_U				movf_f		Duty_cycle, sp_u							
						load_f		sp_u, FSR
						clrw
						call		EE_write_byte
						goto 		Loop

Save_T					movf_ff	sp_tmp+1, sp_t,	r_sim					
						movf_ff	sp_tmp+2, sp_t+1, r_dec	
						call		BCD_BC1
						load_f		sp_t, FSR
						load_f		.2,	ee_size
						movlw		.1
						call		EE_write
						goto 		Loop
						
Save_H					movf_f		sp_tmp, sp_h	
						movf_f		sp_tmp+2, sp_h+1						
						clrf		sp_h+2		;movf_f		sp_tmp+2, sp_h+1	
						load_f		sp_h, FSR
						load_f		.2,	ee_size
						movlw		.3					;  EEPROM
						call		EE_write
						bcf			over_time
						bsf			min_elapsed
						bsf			reset_oh
						goto 		Loop						
;**********************  SP *********************
Load_Tsp				btfsc		edit_on
						goto		Loop			;return
							
						clrf 	SEG_1
						clrf		 Fig
						movf_ff	sp_t, SEG_10, Fig+1
						movf_ff	sp_t+1, SEG_100, Fig+2
;----------------------------    SP---------------------						
						load_f	1, input
;------------------------------   SP--------------------------------
						load_f	0xB8, mask		; 
						clrf		 	mask+1		
						goto	View_SP
												
;**********************  SP  ******************
Load_Hsp				btfsc		edit_on
						goto		Loop			;return
						movf_ff	sp_h, 	SEG_1, Fig
						movf_ff	sp_h+1, SEG_100, Fig+2
						;movf_ff	sp_h+2, SEG_100, Fig+2
						clrf		SEG_10
;----------------------------    SP---------------------						
						load_f	3, input
;------------------------------   SP--------------------------------
						clrf		 	mask
						load_f	0x96, mask+1		; "h"  2 	
						;clrf			mask+1				
;*************************************************************************
;----------------------------- SetPoint  ------------------------------------
View_SP				call		Decoder
						MASKA_F		mask, figure+3
						MASKA_F		mask+1, figure+2				
						
						movf_f	figure+1, digit		
						movf_f	figure+2, digit+1
						movf_f	figure+3, digit+2
						bsf		edit_on			; 
						bsf		flash			; 
						bsf		kn_enable	;  +  -
						goto	Loop

;************************************************************************
;-----------------------------   UP-----------------------------------

Value_UP0				movlw		HIGH(Increase)	;
						movwf		PCLATH
						movfw		input
						call		Increase
;-----------------------------  ------------------------------------------
Save_Tmp				movf_ff	Fig,   SEG_1, sp_tmp
						movf_ff	Fig+1, SEG_10,  sp_tmp+1 
						movf_ff	Fig+2, SEG_100, sp_tmp+2 
						
						goto		View_SP
;----------------------------  UP---------------------------------------------
Value_UP1				movlw		HIGH(Increase)	;
						movwf		PCLATH
						incf			input, w
						call			Increase
;----------------------  -----------------------------------------						
Inc_Speed				movfw		speed_repeat
						sublw		.3
						btfss		STATUS, Z
						decf		speed_repeat
						goto		Save_Tmp

;-----------------------------   DOWN------------------------------
Value_DW0			movlw		HIGH(Decrease)	;
						movwf		PCLATH
						movfw		input
						call			Decrease
						goto		Save_Tmp
;------------------------------  DOWN--------------------------------------
Value_DW1			movlw		HIGH(Decrease)	;
						movwf		PCLATH
						incf			input, w
						call			Decrease
						goto		Inc_Speed

;---------------------------------- ----------------------------------------
Increase	addwf   	PCL	
			goto	ADD0
			goto	ADD1
			goto	ADD2
			goto	ADD5
			goto	ADD2
ADD5		INCR5 	Fig
			goto	ADD2
ADD0		INCR	Fig
ADD1		INCR	Fig+1
ADD2		INCR	Fig+2
			return
;---------------------------------- ----------------------------------------
Decrease	addwf   	PCL	
			goto	SUBT0
			goto	SUBT1
			goto	SUBT2
			goto	SUBT5
			goto	SUBT2
SUBT5		DECR5 	Fig
			goto	SUBT2
SUBT0		DECR	Fig
SUBT1		DECR	Fig+1
SUBT2		DECR	Fig+2
			return					
;*****  3 ****************************************************
delay_3s      movlw .4
	             movwf cnt1 
	             clrf cnt2 
	             clrf cnt3 
dloop           decfsz cnt3,f 
	             goto $+2 
	             decfsz cnt2,f 
	             goto $+2 
	             decfsz cnt1,f 
	             goto dloop 
	             return

;*****  1,2ms*******************************************************
delay_1ms      movlw .2 
	             movwf cnt1 
	             clrf cnt2 
	             
		       decfsz cnt2,f 
	             goto $+2 
	             decfsz cnt1,f 
	             goto $-3
	             return
;******** 40 ****************************************************
DELAY_40
				 movlw   	.25
				 movwf   	cnt1
				 decfsz  	cnt1
				 goto    	$-1
				 return
;***********************************************************************
;********** AD  ********************************
;***********************************************************************
AD_convert		
		;call		delay_1ms
		bsf		AD_start		; 
		nop
		btfsc	AD_start
		goto 	$-1
		
		movfw	ADRESH		;  
		movwf	H_byte
		
		movlw ADRESL	
		movwf FSR 			;  .   
		movfw INDF 			;  
		movwf L_byte
	
	; 16 
		movfw	H_byte		;  
		addwf	H_sum
		
		movfw	L_byte		;  
		addwf	L_sum
		
		btfsc	STATUS, C	;  
		incf		H_sum			;  
		
		return
;		incf		count_sampl	;  
;		btfss	count_sampl, 4
;		
;		
;	
;	;  8
;		
;		clrf		count_sampl
;nm		incf		count_sampl
;		bcf		STATUS, C			;   2
;		rrf		H_sum
;		rrf		L_sum
;		
;		movfw 	count_sampl
;		sublw 	.3
;		btfss 	STATUS, Z 				; 3  elapsed?
;		goto	nm						; no, done
;		
;		;movf_f	H_sum, H_byte
;		;movf_f	L_sum, L_byte
;			
;		bsf		flags1, 7			; 	
;
;		clrf		count_sampl
;		return		

;**************************************************************
;**********  *****************
;**************************************************************
Format				nop
Volt_Format      	btfss	over_time
					btfsc	SU_off
					goto	Exit_Format_U
					
					;btfsc	mode_off
					;goto	Exit_Format_U
					
					movf_f	Usum_H, H_sum
					movf_f	Usum_L, L_sum
;					movf_f	H_sum, BIT_H
;	    				movf_f	L_sum, BIT_L
					movlw	.3
			       	movwf	ratio
			       	call		Divide				;  
	       		
	       		call			BC2_BCD	
			
				  movf    	SEG_1K			; 0   
			        btfss   	STATUS, Z
			        goto    	$+4
			        movlw	0xFE	;  
			        movwf	digit_u
				  goto		$+4	
			
				movfw		SEG_1K
				call    		TABLE
				movwf   	digit_u
				movfw		SEG_100
				call    		TABLE
				movwf   	digit_u+1
	           	     	movfw		SEG_10
				call    		TABLE
				movwf   	digit_u+2
	       	
Exit_Format_U	       	clrf		Usum_H
						clrf		Usum_L
	       	;clrf		H_sum				; 
			;clrf		L_sum				
	        
	        
;*********************************************************************
;************************ *****************
;*********************************************************************				
T_Format			movf_f	Tsum_H, H_sum
					movf_f	Tsum_L, L_sum
			       	movlw	.5
			       	movwf	ratio
			       	call		Divide				;  
			       				
;-----------------------    ---------------------------------------
Compare	movfw	BIT_L
			subwf	sp_th, w			
			movwf	Err
			
			movf	Err, f
			btfsc	STATUS, Z	
			goto	Source_off			;   SP=Tcurrent
			btfsc	Err, 7
			goto	Source_off			;  SP<Tcurrent
			; 	SP>Tcurrent
		     	
		     	btfss	SU_off
			goto	Source_on
		     	
		     	movfw	hister
			subwf	Err, w
			btfsc	STATUS, C	
			goto	Source_on		; >=    
			goto	Source_off		; < 	 					
;----------------------------------------------------------------------------------------------------					
Source_off			btfsc	SU_off
					goto	Decoder_in;Exit_Format
					Off_Out				
					bsf			flash
					load_f	0xFF, digit_u
					load_f	80, digit_u+1
					load_f	0x0E, digit_u+2
					clrf		n_param
					bsf		SU_off
					bcf		SU_on
					goto	Decoder_in;Exit_Format
					
					
Source_on			btfss	mode_off
					btfsc	SU_on
					goto	Decoder_in
					On_Out
					bcf		flash			;  
					bcf		displ_off			; 	
					bcf		SU_off
					bsf		SU_on

Decoder_in			call		BC2_BCD
					call		Decoder
					movf_f	figure+2, digit_t
					movf_f	figure+3, digit_t+1
					load_f	38, 	digit_t+2
							
Exit_Format		clrf			Tsum_H
					clrf			Tsum_L	
					
					return			
;**************************************************************************
;**********  bc  bcd. 16- ***********
;**************************************************************************
BC2_BCD		              ; Takes number in BIT_H:BIT_L 
                          ; Returns decimal in 
                          ; SEG_10K:SEG_1K:SEG_100:SEG_10:SEG_1 

			 CLRF	SEG_10K
			 CLRF	SEG_1K
			 CLRF	SEG_100
			 CLRF	SEG_10
			 CLRF	SEG_1
			    swapf BIT_H,w 
				IORLW b'11110000'
			    movwf SEG_1K 
			    addwf SEG_1K,f 
			    addlw 0xE2 
			    movwf SEG_100 
			    addlw 0x32 
			    movwf SEG_1 
			
			    movf BIT_H,w 
			    andlw 0x0F 
			    addwf SEG_100,f 
			    addwf SEG_100,f 
			    addwf SEG_1,f 
			    addlw 0xE9 
			    movwf SEG_10 
			    addwf SEG_10,f 
			    addwf SEG_10,f 
			
			    swapf BIT_L,w 
			    andlw 0x0F 
			    addwf SEG_10,f 
			    addwf SEG_1,f 
			               
			    rlf SEG_10,f 
			    rlf SEG_1,f 
			    comf SEG_1,f 
			    rlf SEG_1,f 
			             
			    movf BIT_L,w 
			    andlw 0x0F 
			    addwf SEG_1,f 
			    rlf SEG_1K,f 
			               
			    movlw 0x07 
			    movwf SEG_10K 
			               
			    movlw 0x0A                ; Ten 
Lb1: 
			    addwf SEG_1,f 
			    decf SEG_10,f 
			    btfss 3,0 
			    goto Lb1 
Lb2: 
			    addwf SEG_10,f 
			    decf SEG_100,f 
			    btfss 3,0 
			    goto Lb2 
Lb3: 
			    addwf SEG_100,f 
			    decf SEG_1K,f 
			    btfss 3,0 
			    goto Lb3 
Lb4: 
			    addwf SEG_1K,f 
			    decf SEG_10K,f 
			    btfss 3,0 
			    goto Lb4 
			    RETURN 
;*********************************************************************
;****************  ratio***************************************
;*********************************************************************
Divide		
		clrf		count_sampl2
mm		incf		count_sampl2, f
		bcf		STATUS, C			;   2
		rrf		H_sum
		rrf		L_sum
		
		movfw 	count_sampl2
		subwf 	ratio, w
		btfss 	STATUS, Z 				; 3  elapsed?
		goto	mm							; no, done
		
		movfw	H_sum
		movwf	BIT_H
		
		movfw	L_sum
		movwf	BIT_L
		
		clrf		count_sampl2
		return		
;*********************************************************************
;******************* LED**************************************
;*********************************************************************
Decoder
				movfw		SEG_1K
				call    		TABLE
				movwf   	figure
				movfw		SEG_100
				call    		TABLE
				movwf   	figure+1
		        	movfw		SEG_10
				call    		TABLE
				movwf   	figure+2
		       	movfw		SEG_1
				call    		TABLE
				movwf   	figure+3
		       	return

;*******************************************************************
;*************** EEPROM READ/WRITE ( chip_mk.ru (Alex)************
;********************************************************************
EE_read	nop
			load_f	.6, ee_size		; 6 
			load_f 	sp_u, FSR		;   FSR
			
			banksel	EEADR
			clrf		EEADR	;   
Next_read	
			banksel	EECON1
			bsf		EECON1,RD
			banksel	EEDATA
			movfw	EEDATA
			movwf	INDF
					
			incf		EEADR
			movfw	EEADR
			incf		FSR
			decfsz 	ee_size
			goto 	Next_read
			clrf		STATUS
			return					         				       			       	
;*************************************************************************
EE_write_byte			;   1- 
	
	banksel	EEADR
	movwf	EEADR
	movf	INDF,W
	movwf	EEDATA      
	banksel	EECON1
	bsf		EECON1,WREN
	bcf       INTCON,GIE  ;   .
	movlw	0x55
	movwf	EECON2
	movlw	0xAA
	movwf	EECON2
	bsf		EECON1,WR
	btfsc 	EECON1,WR
	goto 	$-1
	bsf        INTCON,GIE
	clrf		STATUS
	return;
EE_write			;    
	call 	EE_write_byte
	banksel	EEADR
	incf		EEADR,F
	movf	EEADR,W
	incf		FSR,F
	decfsz 	ee_size
	goto 	EE_write
	clrf		STATUS
	return
;***********************************************************************
;********  bcd  bc. 8- ***********
;***********************************************************************
BCD_BC1
			;in sp_t, sp_t+1
			;out: sp_tH
			 movfw		r_sim
			 movwf		sp_th
			 tstf		r_dec
			 skpnz
			 return
			 movlw		.10
			 addwf		sp_th,f
			 decfsz		r_dec,f
			 goto		$-3
			 return	

;************************************************************************
;-----------        SP----------	
;************************************************************************		
Time_compare		btfss	mode_off		;    -  
					btfsc	over_time		;   -  
					return		
					
					movf	sp_h+1, f
					bnz		C_t1
					movf	sp_h, f
					bnz		C_t1
					return
;					movfw	 hours_10
;					subwf	sp_h+2, w
;					bz		C_t1
;					bnc		Time_elapsed
;					return
					
C_t1				movfw	 count_hour
					subwf	sp_h+1, w
					bz		C_t2
					bnc		Time_elapsed
					return
					
C_t2				movfw	 mins_10
					subwf	sp_h, w
					bz		Time_elapsed
					bnc		Time_elapsed
					return
;-----------------------  ---------------------------------------------------		
Time_elapsed		Off_Out				
					bsf		flash
					load_f	0xFF, digit_u
					load_f	80, digit_u+1
					load_f	16, digit_u+2
					clrf		n_param
					bsf		over_time
					bcf		kn_enable	;  +  -
					return
;***********************************************************************	
	ORG	0x2100
	DE		0x55, 0x00, 0x05, 0x05,0x09, 0x00, 0x00, 0x05
	DE		0x06, 0x00, 0x05, 0x03,0x00, 0x00, 0x00, 0x00
	
	END                       ; directive 'end of program'

